=== tests/CMakeLists.txt ===
add_subdirectory(catch)
add_subdirectory(pytest)
