=== tutorials/CMakeLists.txt ===
install( FILES 
        boxcyl.geo circle_on_cube.geo cone.geo cube.geo			   
        cubeandring.geo cubeandspheres.geo cubemcyl.geo cubemsphere.geo cylinder.geo	   
        cylsphere.geo ellipsoid.geo ellipticcyl.geo extrusion.geo fichera.geo lshape3d.geo 
        manyholes.geo manyholes2.geo matrix.geo ortho.geo period.geo revolution.geo	   
        sculpture.geo shaft.geo shell.geo sphere.geo sphereincube.geo torus.geo trafo.geo  
        twobricks.geo twocubes.geo twocyl.geo boundarycondition.geo			   
        hinge.stl  part1.stl frame.step  screw.step					   
        squarehole.in2d squarecircle.in2d square.in2d
        DESTINATION ${NG_INSTALL_DIR_RES}/${NG_INSTALL_SUFFIX}
        COMPONENT netgen_tutorial
       )
