=== debian/changelog ===
netgen (6.2.2006+really6.2.1905+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/4fad6e0631718a4bb574d67505e0ebfef1f171ce.patch:
    - upstream fix for armhf build failure (Closes: #984439)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Apr 2021 14:05:03 +0200
