=== debian/tests/control ===
Test-Command: set -e ; cd "$AUTOPKGTEST_TMP" ; echo "Testing with python3:" ; python3 -c "import netgen; print(netgen)"
Depends: python3, python3-netgen
